diff -Nurp linux-2.4.22-clean/arch/mips/kernel/traps.c linux-2.4.22-adeos-ltt/arch/mips/kernel/traps.c
--- linux-2.4.22-clean/arch/mips/kernel/traps.c	2003-08-25 04:44:40.000000000 -0700
+++ linux-2.4.22-adeos-ltt/arch/mips/kernel/traps.c	2003-11-21 23:21:08.000000000 -0800
@@ -19,6 +19,7 @@
 #include <linux/smp.h>
 #include <linux/smp_lock.h>
 #include <linux/spinlock.h>
+#include <linux/trace.h>
 
 #include <asm/bootinfo.h>
 #include <asm/branch.h>
@@ -38,6 +39,7 @@
 #include <asm/traps.h>
 #include <asm/uaccess.h>
 #include <asm/mmu_context.h>
+#include <asm/unistd.h>
 
 extern asmlinkage void handle_mod(void);
 extern asmlinkage void handle_tlbl(void);
@@ -349,6 +351,8 @@ asmlinkage void do_be(struct pt_regs *re
 	int data = regs->cp0_cause & 4;
 	int action = MIPS_BE_FATAL;
 
+	TRACE_TRAP_ENTRY(CAUSE_EXCCODE(regs), CAUSE_EPC(regs));
+
 	if (data && !user_mode(regs))
 		fixup = search_dbe_table(regs->cp0_epc);
 
@@ -360,12 +364,14 @@ asmlinkage void do_be(struct pt_regs *re
 
 	switch (action) {
 	case MIPS_BE_DISCARD:
+		TRACE_TRAP_EXIT();
 		return;
 	case MIPS_BE_FIXUP:
 		if (fixup) {
 			new_epc = fixup_exception(dpf_reg, fixup,
 						  regs->cp0_epc);
 			regs->cp0_epc = new_epc;
+			TRACE_TRAP_EXIT();
 			return;
 		}
 		break;
@@ -381,18 +387,22 @@ asmlinkage void do_be(struct pt_regs *re
 	       regs->cp0_epc, regs->regs[31]);
 	die_if_kernel("Oops", regs);
 	force_sig(SIGBUS, current);
+	TRACE_TRAP_EXIT();
 }
 
 static inline int get_insn_opcode(struct pt_regs *regs, unsigned int *opcode)
 {
 	unsigned int *epc;
 
+	TRACE_TRAP_ENTRY(CAUSE_EXCCODE(regs), CAUSE_EPC(regs));
+
 	epc = (unsigned int *) regs->cp0_epc +
 	      ((regs->cp0_cause & CAUSEF_BD) != 0);
 	if (!get_user(*opcode, epc))
 		return 0;
 
 	force_sig(SIGSEGV, current);
+ 	TRACE_TRAP_EXIT(); 	
 	return 1;
 }
 
@@ -517,10 +527,12 @@ static inline int simulate_llsc(struct p
 
 	if ((opcode & OPCODE) == LL) {
 		simulate_ll(regs, opcode);
+		TRACE_TRAP_EXIT();
 		return 0;
 	}
 	if ((opcode & OPCODE) == SC) {
 		simulate_sc(regs, opcode);
+		TRACE_TRAP_EXIT();
 		return 0;
 	}
 }
@@ -528,12 +540,14 @@ static inline int simulate_llsc(struct p
 asmlinkage void do_ov(struct pt_regs *regs)
 {
 	siginfo_t info;
+ 	TRACE_TRAP_ENTRY(CAUSE_EXCCODE(regs), CAUSE_EPC(regs));
 
 	info.si_code = FPE_INTOVF;
 	info.si_signo = SIGFPE;
 	info.si_errno = 0;
 	info.si_addr = (void *)regs->cp0_epc;
 	force_sig_info(SIGFPE, &info, current);
+ 	TRACE_TRAP_EXIT();
 }
 
 /*
@@ -541,6 +555,7 @@ asmlinkage void do_ov(struct pt_regs *re
  */
 asmlinkage void do_fpe(struct pt_regs *regs, unsigned long fcr31)
 {
+	TRACE_TRAP_ENTRY(CAUSE_EXCCODE(regs), CAUSE_EPC(regs));
 	if (fcr31 & FPU_CSR_UNI_X) {
 		int sig;
 
@@ -572,11 +587,15 @@ asmlinkage void do_fpe(struct pt_regs *r
 		/* If something went wrong, signal */
 		if (sig)
 			force_sig(sig, current);
-
+ 		TRACE_TRAP_EXIT();
 		return;
 	}
-
+ 	if (compute_return_epc(regs)){
+ 		TRACE_TRAP_EXIT();
+   		return;
+ 	}
 	force_sig(SIGFPE, current);
+ 	TRACE_TRAP_EXIT();
 }
 
 asmlinkage void do_bp(struct pt_regs *regs)
@@ -615,6 +634,7 @@ asmlinkage void do_bp(struct pt_regs *re
 	default:
 		force_sig(SIGTRAP, current);
 	}
+	TRACE_TRAP_EXIT();
 }
 
 asmlinkage void do_tr(struct pt_regs *regs)
@@ -649,7 +669,10 @@ asmlinkage void do_tr(struct pt_regs *re
 		break;
 	default:
 		force_sig(SIGTRAP, current);
+		
 	}
+ 	TRACE_TRAP_EXIT();
+	
 }
 
 asmlinkage void do_ri(struct pt_regs *regs)
@@ -661,6 +684,7 @@ asmlinkage void do_ri(struct pt_regs *re
 			return;
 
 	force_sig(SIGILL, current);
+	TRACE_TRAP_EXIT();
 }
 
 asmlinkage void do_cpu(struct pt_regs *regs)
@@ -669,6 +693,8 @@ asmlinkage void do_cpu(struct pt_regs *r
 
 	die_if_kernel("do_cpu invoked from kernel context!", regs);
 
+	TRACE_TRAP_ENTRY(CAUSE_EXCCODE(regs), CAUSE_EPC(regs));
+
 	cpid = (regs->cp0_cause >> CAUSEB_CE) & 3;
 
 	switch (cpid) {
@@ -1016,3 +1042,75 @@ void __init trap_init(void)
 	current_cpu_data.asid_cache = ASID_FIRST_VERSION;
 	TLBMISS_HANDLER_SETUP();
 }
+
+#if (CONFIG_TRACE || CONFIG_TRACE_MODULE)
+asmlinkage void trace_real_syscall_entry(struct pt_regs * regs)
+{
+	unsigned long       addr;
+	int                 depth = 0;
+	unsigned long       end_code;
+	unsigned long       lower_bound;
+	int                 seek_depth;
+	unsigned long       *stack;
+	unsigned long       start_code;
+	unsigned long       *start_stack;
+	trace_syscall_entry trace_syscall_event;
+	unsigned long       upper_bound;
+	int                 use_bounds;
+	int                 use_depth;
+
+	/* syscall_id will be negative for SVR4, IRIX5, BSD43, and POSIX
+	 * syscalls -- these are not supported at this point by LTT
+	 */
+	trace_syscall_event.syscall_id = (uint8_t) (regs->regs[2] - __NR_Linux);
+
+	trace_syscall_event.address  = regs->cp0_epc;
+
+	if (!user_mode(regs))
+		goto trace_syscall_end;
+
+	if (trace_get_config(&use_depth,
+			     &use_bounds,
+			     &seek_depth,
+			     (void*)&lower_bound,
+			     (void*)&upper_bound) < 0)
+		goto trace_syscall_end;
+
+	/* Heuristic that might work:
+	 * (BUT DOESN'T WORK for any of the cases I tested...) zzz
+	 * Search through stack until a value is found that is within the
+	 * range start_code .. end_code.  (This is looking for a return
+	 * pointer to where a shared library was called from.)  If a stack
+	 * variable contains a valid code address then an incorrect
+	 * result will be generated.
+	 */
+	if ((use_depth == 1) || (use_bounds == 1)) {
+		stack       = (unsigned long*) regs->regs[29];
+		end_code    = current->mm->end_code;
+		start_code  = current->mm->start_code;
+		start_stack = (unsigned long *)current->mm->start_stack;
+
+		while ((stack <= start_stack) && (!__get_user(addr, stack))) {
+			if ((addr > start_code) && (addr < end_code)) {
+				if (((use_depth  == 1) && (depth == seek_depth)) ||
+				    ((use_bounds == 1) && (addr > lower_bound) && (addr < upper_bound))) {
+					trace_syscall_event.address = addr;
+					goto trace_syscall_end;
+				} else {
+					depth++;
+				}
+			}
+		stack++;
+		}
+	}
+
+trace_syscall_end:
+	trace_event(TRACE_EV_SYSCALL_ENTRY, &trace_syscall_event);
+}
+
+asmlinkage void trace_real_syscall_exit(void)
+{
+        trace_event(TRACE_EV_SYSCALL_EXIT, NULL);
+}
+
+#endif /* (CONFIG_TRACE || CONFIG_TRACE_MODULE) */
diff -Nurp linux-2.4.22-clean/arch/mips/kernel/unaligned.c linux-2.4.22-adeos-ltt/arch/mips/kernel/unaligned.c
--- linux-2.4.22-clean/arch/mips/kernel/unaligned.c	2003-08-25 04:44:40.000000000 -0700
+++ linux-2.4.22-adeos-ltt/arch/mips/kernel/unaligned.c	2003-11-21 23:21:08.000000000 -0800
@@ -77,6 +77,7 @@
 #include <linux/signal.h>
 #include <linux/smp.h>
 #include <linux/smp_lock.h>
+#include <linux/trace.h>
 
 #include <asm/asm.h>
 #include <asm/branch.h>
@@ -502,6 +503,7 @@ asmlinkage void do_ade(struct pt_regs *r
 	extern int do_dsemulret(struct pt_regs *);
 	mm_segment_t seg;
 	unsigned long pc;
+        TRACE_TRAP_ENTRY(CAUSE_EXCCODE(regs), CAUSE_EPC(regs));
 
 	/*
 	 * Address errors may be deliberately induced by the FPU emulator to
@@ -509,8 +511,10 @@ asmlinkage void do_ade(struct pt_regs *r
 	 * delay slot of an emulated branch.
 	 */
 	/* Terminate if exception was recognized as a delay slot return */
-	if (do_dsemulret(regs))
+	if (do_dsemulret(regs)) {
+		TRACE_TRAP_EXIT();
 		return;
+	}
 
 	/* Otherwise handle as normal */
 
@@ -544,6 +548,8 @@ asmlinkage void do_ade(struct pt_regs *r
 	}
 	set_fs(seg);
 
+	TRACE_TRAP_EXIT();
+	TRACE_TRAP_EXIT();
 	return;
 
 sigbus:
diff -Nurp linux-2.4.22-clean/arch/mips/mm/fault.c linux-2.4.22-adeos-ltt/arch/mips/mm/fault.c
--- linux-2.4.22-clean/arch/mips/mm/fault.c	2003-08-25 04:44:40.000000000 -0700
+++ linux-2.4.22-adeos-ltt/arch/mips/mm/fault.c	2003-11-21 23:21:08.000000000 -0800
@@ -19,6 +19,7 @@
 #include <linux/smp.h>
 #include <linux/smp_lock.h>
 #include <linux/version.h>
+#include <linux/trace.h>
 #include <linux/vt_kern.h>
 
 #include <asm/branch.h>
@@ -28,6 +29,7 @@
 #include <asm/softirq.h>
 #include <asm/system.h>
 #include <asm/uaccess.h>
+#include <asm/mipsregs.h>
 
 #define development_version (LINUX_VERSION_CODE & 0x100)
 
@@ -83,6 +85,8 @@ asmlinkage void do_page_fault(struct pt_
 	unsigned long fixup;
 	siginfo_t info;
 
+	TRACE_TRAP_ENTRY(CAUSE_EXCCODE(regs), CAUSE_EPC(regs));
+
 	/*
 	 * We fault-in kernel-space virtual memory on-demand. The
 	 * 'reference' page table is init_mm.pgd.
@@ -151,6 +155,7 @@ survive:
 	}
 
 	up_read(&mm->mmap_sem);
+	TRACE_TRAP_EXIT();
 	return;
 
 /*
@@ -178,6 +183,7 @@ bad_area:
 		/* info.si_code has been set above */
 		info.si_addr = (void *) address;
 		force_sig_info(SIGSEGV, &info, tsk);
+		TRACE_TRAP_EXIT();
 		return;
 	}
 
@@ -193,6 +199,7 @@ no_context:
 			printk(KERN_DEBUG "%s: Exception at [<%lx>] (%lx)\n",
 			       tsk->comm, regs->cp0_epc, new_epc);
 		regs->cp0_epc = new_epc;
+		TRACE_TRAP_EXIT();
 		return;
 	}
 
@@ -239,6 +246,7 @@ do_sigbus:
 	if (!user_mode(regs))
 		goto no_context;
 
+	TRACE_TRAP_EXIT();
 	return;
 
 vmalloc_fault:
@@ -273,4 +281,5 @@ vmalloc_fault:
 			goto no_context;
 		return;
 	}
+	TRACE_TRAP_EXIT();
 }
diff -Nurp linux-2.4.22-clean/arch/ppc/config.in linux-2.4.22-adeos-ltt/arch/ppc/config.in
--- linux-2.4.22-clean/arch/ppc/config.in	2003-08-25 04:44:40.000000000 -0700
+++ linux-2.4.22-adeos-ltt/arch/ppc/config.in	2003-11-21 23:21:08.000000000 -0800
@@ -441,6 +441,11 @@ source crypto/Config.in
 source lib/Config.in
 
 mainmenu_option next_comment
+comment 'Kernel tracing'
+tristate 'Kernel events tracing support' CONFIG_TRACE
+endmenu
+
+mainmenu_option next_comment
 comment 'Kernel hacking'
 
 bool 'Kernel debugging' CONFIG_DEBUG_KERNEL
diff -Nurp linux-2.4.22-clean/arch/ppc/kernel/entry.S linux-2.4.22-adeos-ltt/arch/ppc/kernel/entry.S
--- linux-2.4.22-clean/arch/ppc/kernel/entry.S	2003-08-25 04:44:40.000000000 -0700
+++ linux-2.4.22-adeos-ltt/arch/ppc/kernel/entry.S	2003-11-21 23:21:08.000000000 -0800
@@ -39,6 +39,32 @@ show_syscalls_task:
 	.long	-1
 #endif
 
+/* LTT stuff */
+#if (CONFIG_TRACE || CONFIG_TRACE_MODULE)
+#define TRACE_REAL_ASM_SYSCALL_ENTRY	\
+	addi	r3,r1,STACK_FRAME_OVERHEAD;  	/* Put pointer to registers into r3 */	\
+	mflr	r29;				/* Save LR */ \
+	bl	trace_real_syscall_entry;	/* Call real trace function */ \
+	mtlr	r29;				/* Restore LR */ \
+	lwz	r0,GPR0(r1);			/* Restore original registers */ \
+	lwz	r3,GPR3(r1);	\
+	lwz	r4,GPR4(r1);	\
+	lwz	r5,GPR5(r1);	\
+	lwz	r6,GPR6(r1);	\
+	lwz	r7,GPR7(r1);	\
+	lwz	r8,GPR8(r1);
+#define TRACE_REAL_ASM_SYSCALL_EXIT \
+	bl	trace_real_syscall_exit;	/* Call real trace function */ \
+	lwz	r0,GPR0(r1);			/* Restore original registers */ \
+	lwz	r3,RESULT(r1); \
+	lwz	r4,GPR4(r1); \
+	lwz	r5,GPR5(r1); \
+	lwz	r6,GPR6(r1); \
+	lwz	r7,GPR7(r1); \
+	lwz	r8,GPR8(r1); \
+	addi	r9,r1,STACK_FRAME_OVERHEAD;
+#endif
+
 /*
  * Handle a system call.
  */
@@ -96,11 +122,17 @@ _GLOBAL(DoSyscall)
 	cmpi	0,r10,0
 	beq-	66f
 	mtlr	r10
+#if (CONFIG_TRACE || CONFIG_TRACE_MODULE)
+	TRACE_REAL_ASM_SYSCALL_ENTRY ;
+#endif
 	addi	r9,r1,STACK_FRAME_OVERHEAD
 	blrl			/* Call handler */
 	.globl	ret_from_syscall_1
 ret_from_syscall_1:
 20:	stw	r3,RESULT(r1)	/* Save result */
+#if (CONFIG_TRACE || CONFIG_TRACE_MODULE)
+	TRACE_REAL_ASM_SYSCALL_EXIT ; 
+#endif
 #ifdef SHOW_SYSCALLS
 #ifdef SHOW_SYSCALLS_TASK
 	cmp	0,r2,r31
@@ -158,11 +190,17 @@ ret_from_syscall_1:
 	cmpi	0,r10,0
 	beq-	66f
 	mtlr	r10
+#if (CONFIG_TRACE || CONFIG_TRACE_MODULE)
+	TRACE_REAL_ASM_SYSCALL_ENTRY ;
+#endif
 	addi	r9,r1,STACK_FRAME_OVERHEAD
 	blrl			/* Call handler */
 	.globl	ret_from_syscall_2
 ret_from_syscall_2:
 	stw	r3,RESULT(r1)	/* Save result */
+#if (CONFIG_TRACE || CONFIG_TRACE_MODULE)
+	TRACE_REAL_ASM_SYSCALL_EXIT ; 
+#endif
 	li	r10,-_LAST_ERRNO
 	cmpl	0,r3,r10
 	blt	60f
diff -Nurp linux-2.4.22-clean/arch/ppc/kernel/irq.c linux-2.4.22-adeos-ltt/arch/ppc/kernel/irq.c
--- linux-2.4.22-clean/arch/ppc/kernel/irq.c	2003-08-25 04:44:40.000000000 -0700
+++ linux-2.4.22-adeos-ltt/arch/ppc/kernel/irq.c	2003-11-21 23:21:08.000000000 -0800
@@ -45,6 +45,8 @@
 #include <linux/proc_fs.h>
 #include <linux/random.h>
 
+#include <linux/trace.h>
+
 #include <asm/uaccess.h>
 #include <asm/bitops.h>
 #include <asm/system.h>
@@ -431,6 +433,8 @@ void ppc_irq_dispatch_handler(struct pt_
 	int cpu = smp_processor_id();
 	irq_desc_t *desc = irq_desc + irq;
 
+	TRACE_IRQ_ENTRY(irq, !(user_mode(regs)));
+
 	kstat.irqs[cpu][irq]++;
 	spin_lock(&desc->lock);
 	ack_irq(irq);
@@ -508,6 +512,8 @@ out:
 			irq_desc[irq].handler->enable(irq);
 	}
 	spin_unlock(&desc->lock);
+
+	TRACE_IRQ_EXIT();
 }
 
 int do_IRQ(struct pt_regs *regs)
diff -Nurp linux-2.4.22-clean/arch/ppc/kernel/misc.S linux-2.4.22-adeos-ltt/arch/ppc/kernel/misc.S
--- linux-2.4.22-clean/arch/ppc/kernel/misc.S	2003-08-25 04:44:40.000000000 -0700
+++ linux-2.4.22-adeos-ltt/arch/ppc/kernel/misc.S	2003-11-21 23:21:08.000000000 -0800
@@ -959,7 +959,11 @@ _GLOBAL(cvt_df)
  * Create a kernel thread
  *   arch_kernel_thread(fn, arg, flags)
  */
+#if (CONFIG_TRACE || CONFIG_TRACE_MODULE)
+_GLOBAL(original_kernel_thread)
+#else
 _GLOBAL(arch_kernel_thread)
+#endif
 	mr	r6,r3		/* function */
 	ori	r3,r5,CLONE_VM	/* flags */
 	li	r0,__NR_clone
diff -Nurp linux-2.4.22-clean/arch/ppc/kernel/process.c linux-2.4.22-adeos-ltt/arch/ppc/kernel/process.c
--- linux-2.4.22-clean/arch/ppc/kernel/process.c	2003-08-25 04:44:40.000000000 -0700
+++ linux-2.4.22-adeos-ltt/arch/ppc/kernel/process.c	2003-11-21 23:21:08.000000000 -0800
@@ -33,6 +33,8 @@
 #include <linux/init.h>
 #include <linux/prctl.h>
 
+#include <linux/trace.h>
+
 #include <asm/pgtable.h>
 #include <asm/uaccess.h>
 #include <asm/system.h>
@@ -305,6 +307,19 @@ out:
 	print_backtrace((unsigned long *)regs->gpr[1]);
 }
 
+#if (CONFIG_TRACE || CONFIG_TRACE_MODULE)
+long original_kernel_thread(int (*fn) (void *), void* arg, unsigned long flags);
+long kernel_thread(int (*fn) (void *), void* arg, unsigned long flags)
+{
+        long   retval;
+
+	retval = original_kernel_thread(fn, arg, flags);
+	if (retval > 0)
+	        TRACE_PROCESS(TRACE_EV_PROCESS_KTHREAD, retval, (int) fn);
+	return retval;
+}
+#endif /* (CONFIG_TRACE || CONFIG_TRACE_MODULE) */
+
 void exit_thread(void)
 {
 	if (last_task_used_math == current)
diff -Nurp linux-2.4.22-clean/arch/ppc/kernel/syscalls.c linux-2.4.22-adeos-ltt/arch/ppc/kernel/syscalls.c
--- linux-2.4.22-clean/arch/ppc/kernel/syscalls.c	2003-08-25 04:44:40.000000000 -0700
+++ linux-2.4.22-adeos-ltt/arch/ppc/kernel/syscalls.c	2003-11-21 23:21:08.000000000 -0800
@@ -36,6 +36,8 @@
 #include <linux/utsname.h>
 #include <linux/file.h>
 
+#include <linux/trace.h>
+
 #include <asm/uaccess.h>
 #include <asm/ipc.h>
 #include <asm/semaphore.h>
@@ -64,6 +66,8 @@ sys_ipc (uint call, int first, int secon
 	version = call >> 16; /* hack for backward compatibility */
 	call &= 0xffff;
 
+	TRACE_IPC(TRACE_EV_IPC_CALL, call, first);
+
 	ret = -EINVAL;
 	switch (call) {
 	case SEMOP:
diff -Nurp linux-2.4.22-clean/arch/ppc/kernel/time.c linux-2.4.22-adeos-ltt/arch/ppc/kernel/time.c
--- linux-2.4.22-clean/arch/ppc/kernel/time.c	2003-08-25 04:44:40.000000000 -0700
+++ linux-2.4.22-adeos-ltt/arch/ppc/kernel/time.c	2003-11-21 23:21:08.000000000 -0800
@@ -57,6 +57,8 @@
 #include <linux/time.h>
 #include <linux/init.h>
 
+#include <linux/trace.h>
+
 #include <asm/segment.h>
 #include <asm/io.h>
 #include <asm/processor.h>
@@ -148,6 +150,8 @@ int timer_interrupt(struct pt_regs * reg
 	if (atomic_read(&ppc_n_lost_interrupts) != 0)
 		do_IRQ(regs);
 
+	TRACE_TRAP_ENTRY(regs->trap, instruction_pointer(regs));
+
 	hardirq_enter(cpu);
 
 	while ((next_dec = tb_ticks_per_jiffy - tb_delta(&jiffy_stamp)) < 0) {
@@ -208,6 +212,8 @@ int timer_interrupt(struct pt_regs * reg
 	if (softirq_pending(cpu))
 		do_softirq();
 
+	TRACE_TRAP_EXIT();
+
 	return 1; /* lets ret_from_int know we can do checks */
 }
 
diff -Nurp linux-2.4.22-clean/arch/ppc/kernel/traps.c linux-2.4.22-adeos-ltt/arch/ppc/kernel/traps.c
--- linux-2.4.22-clean/arch/ppc/kernel/traps.c	2003-08-25 04:44:40.000000000 -0700
+++ linux-2.4.22-adeos-ltt/arch/ppc/kernel/traps.c	2003-11-21 23:21:08.000000000 -0800
@@ -30,6 +30,8 @@
 #include <linux/config.h>
 #include <linux/init.h>
 
+#include <linux/trace.h>
+
 #include <asm/pgtable.h>
 #include <asm/uaccess.h>
 #include <asm/system.h>
@@ -113,7 +115,9 @@ _exception(int signr, struct pt_regs *re
 	info.si_errno = 0;
 	info.si_code = code;
 	info.si_addr = (void *) addr;
+	TRACE_TRAP_ENTRY(regs->trap, instruction_pointer(regs));
 	force_sig_info(signr, &info, current);
+	TRACE_TRAP_EXIT();
 }
 
 /*
@@ -420,6 +424,89 @@ StackOverflow(struct pt_regs *regs)
 	panic("kernel stack overflow");
 }
 
+/* Trace related code */
+#if (CONFIG_TRACE || CONFIG_TRACE_MODULE)
+asmlinkage void trace_real_syscall_entry(struct pt_regs * regs)
+{
+        int                 use_depth;
+	int                 use_bounds;
+	int                 depth = 0;
+        int                 seek_depth;
+        unsigned long       lower_bound;
+        unsigned long       upper_bound;
+	unsigned long       addr;
+	unsigned long*      stack;
+	trace_syscall_entry trace_syscall_event;
+
+        /* Set the syscall ID */
+	trace_syscall_event.syscall_id = (uint8_t) regs->gpr[0];
+
+	/* Set the address in any case */
+	trace_syscall_event.address  = instruction_pointer(regs);
+
+	/* Are we in the kernel (This is a kernel thread)? */
+	if(!user_mode(regs))
+	  /* Don't go digining anywhere */
+	  goto trace_syscall_end;
+
+	/* Get the trace configuration */
+	if(trace_get_config(&use_depth,
+			    &use_bounds,
+			    &seek_depth,
+			    (void*)&lower_bound,
+			    (void*)&upper_bound) < 0)
+	  goto trace_syscall_end;
+
+	/* Do we have to search for an eip address range */
+	if((use_depth == 1) || (use_bounds == 1))
+	  {
+	  /* Start at the top of the stack (bottom address since stacks grow downward) */
+	  stack = (unsigned long*) regs->gpr[1];
+
+	  /* Skip over first stack frame as the return address isn't valid */
+	  if(get_user(addr, stack))
+	    goto trace_syscall_end;
+	  stack = (unsigned long*) addr;
+
+	  /* Keep on going until we reach the end of the process' stack limit (wherever it may be) */
+	  while(!get_user(addr, stack + 1)) /* "stack + 1", since this is where the IP is */
+	    {
+	    /* Does this LOOK LIKE an address in the program */
+	    if((addr > current->mm->start_code)
+             &&(addr < current->mm->end_code))
+	      {
+	      /* Does this address fit the description */
+	      if(((use_depth == 1) && (depth == seek_depth))
+               ||((use_bounds == 1) && (addr > lower_bound) && (addr < upper_bound)))
+		{
+		/* Set the address */
+		trace_syscall_event.address = addr;
+
+		/* We're done */
+		goto trace_syscall_end;
+		}
+	      else
+		/* We're one depth more */
+		depth++;
+	      }
+	    /* Go on to the next address */
+	    if(get_user(addr, stack))
+	      goto trace_syscall_end;
+	    stack = (unsigned long*) addr;
+	    }
+	  }
+
+trace_syscall_end:
+	/* Trace the event */
+	trace_event(TRACE_EV_SYSCALL_ENTRY, &trace_syscall_event);
+}
+
+asmlinkage void trace_real_syscall_exit(void)
+{
+        trace_event(TRACE_EV_SYSCALL_EXIT, NULL);
+}
+#endif /* (CONFIG_TRACE || CONFIG_TRACE_MODULE) */
+
 void
 trace_syscall(struct pt_regs *regs)
 {
diff -Nurp linux-2.4.22-clean/arch/ppc/mm/fault.c linux-2.4.22-adeos-ltt/arch/ppc/mm/fault.c
--- linux-2.4.22-clean/arch/ppc/mm/fault.c	2003-08-25 04:44:40.000000000 -0700
+++ linux-2.4.22-adeos-ltt/arch/ppc/mm/fault.c	2003-11-21 23:21:08.000000000 -0800
@@ -27,6 +27,8 @@
 #include <linux/mm.h>
 #include <linux/interrupt.h>
 
+#include <linux/trace.h>
+
 #include <asm/page.h>
 #include <asm/pgtable.h>
 #include <asm/mmu.h>
@@ -117,22 +119,28 @@ void do_page_fault(struct pt_regs *regs,
 		is_write = error_code & 0x02000000;
 #endif /* CONFIG_4xx */
 
+	TRACE_TRAP_ENTRY(regs->trap, instruction_pointer(regs));
+
 #if defined(CONFIG_XMON) || defined(CONFIG_KGDB)
 	if (debugger_fault_handler && regs->trap == 0x300) {
 		debugger_fault_handler(regs);
+		TRACE_TRAP_EXIT();
 		return;
 	}
 #if !defined(CONFIG_4xx)
 	if (error_code & 0x00400000) {
 		/* DABR match */
-		if (debugger_dabr_match(regs))
+   	        if (debugger_dabr_match(regs)){
+		        TRACE_TRAP_EXIT();
 			return;
+		}
 	}
 #endif /* !CONFIG_4xx */
 #endif /* CONFIG_XMON || CONFIG_KGDB */
 
 	if (in_interrupt() || mm == NULL) {
 		bad_page_fault(regs, address, SIGSEGV);
+		TRACE_TRAP_EXIT();
 		return;
 	}
 	down_read(&mm->mmap_sem);
@@ -237,6 +245,7 @@ good_area:
 	 * -- Cort
 	 */
 	pte_misses++;
+	TRACE_TRAP_EXIT();
 	return;
 
 bad_area:
@@ -250,10 +259,12 @@ bad_area:
 		info.si_code = code;
 		info.si_addr = (void *) address;
 		force_sig_info(SIGSEGV, &info, current);
+		TRACE_TRAP_EXIT();
 		return;
 	}
 
 	bad_page_fault(regs, address, SIGSEGV);
+	TRACE_TRAP_EXIT();
 	return;
 
 /*
@@ -270,6 +281,7 @@ out_of_memory:
 	if (user_mode(regs))
 		do_exit(SIGKILL);
 	bad_page_fault(regs, address, SIGKILL);
+	TRACE_TRAP_EXIT();
 	return;
 
 do_sigbus:
@@ -281,6 +293,7 @@ do_sigbus:
 	force_sig_info (SIGBUS, &info, current);
 	if (!user_mode(regs))
 		bad_page_fault(regs, address, SIGBUS);
+	TRACE_TRAP_EXIT();
 }
 
 /*
diff -Nurp linux-2.4.22-clean/arch/s390/config.in linux-2.4.22-adeos-ltt/arch/s390/config.in
--- linux-2.4.22-clean/arch/s390/config.in	2003-08-25 04:44:40.000000000 -0700
+++ linux-2.4.22-adeos-ltt/arch/s390/config.in	2003-11-21 23:21:08.000000000 -0800
@@ -70,6 +70,11 @@ fi
 source fs/Config.in
 
 mainmenu_option next_comment
+comment 'Kernel tracing'                             
+tristate 'Kernel events tracing support' CONFIG_TRACE
+endmenu                                              
+
+mainmenu_option next_comment
 comment 'Kernel hacking'
 
 #bool 'Debug kmalloc/kfree' CONFIG_DEBUG_MALLOC
diff -Nurp linux-2.4.22-clean/arch/s390/kernel/entry.S linux-2.4.22-adeos-ltt/arch/s390/kernel/entry.S
--- linux-2.4.22-clean/arch/s390/kernel/entry.S	2003-06-13 07:51:32.000000000 -0700
+++ linux-2.4.22-adeos-ltt/arch/s390/kernel/entry.S	2003-11-21 23:21:08.000000000 -0800
@@ -7,6 +7,7 @@
  *    Author(s): Martin Schwidefsky (schwidefsky@de.ibm.com),
  *               Hartmut Penner (hp@de.ibm.com),
  *               Denis Joseph Barrow (djbarrow@de.ibm.com,barrow_dj@yahoo.com),
+ *  Portions added by T. Halloran: (C) Copyright 2002 IBM Poughkeepsie, IBM Corporation
  */
 
 #include <linux/sys.h>
@@ -179,6 +180,14 @@ system_call:
         sll     %r8,2
         GET_CURRENT               # load pointer to task_struct to R9
         stosm   24(%r15),0x03     # reenable interrupts
+/* call to ltt trace done here.  R8 has the syscall (svc) number to trace */
+#if (CONFIG_TRACE || CONFIG_TRACE_MODULE) /* tjh - ltt port */              
+        /* add call to trace_real_syscall_entry */                          
+        la      %r2,SP_PTREGS(%r15)   # load pt_regs as first parameter     
+        l       %r1,BASED(.Ltracesysent)                                    
+        basr    %r14,%r1                                                    
+        lm      %r0,%r6,SP_R0(%r15) /* restore call clobbered regs tjh */   
+#endif
         l       %r8,sys_call_table-entry_base(%r8,%r13) # get system call addr.
         tm      __TASK_ptrace+3(%r9),0x02 # PT_TRACESYS
         bnz     BASED(sysc_tracesys)
@@ -187,6 +196,13 @@ system_call:
                                   # ATTENTION: check sys_execve_glue before
                                   # changing anything here !!
 
+#if (CONFIG_TRACE || CONFIG_TRACE_MODULE) /* tjh - ltt port *            
+        /* add call to trace_real_syscall_exit */ 
+        la      %r2,SP_PTREGS(%r15)   # load pt_regs as first parameter  
+        l       %r1,BASED(.Ltracesysext)                                 
+        basr    %r14,%r1                                                 
+        lm      %r0,%r6,SP_R0(%r15) /* restore call clobbered regs */
+#endif                                                                   
 sysc_return:
         tm      SP_PSW+1(%r15),0x01 # returning to user ?
         bno     BASED(sysc_leave) # no-> skip resched & signal
@@ -867,6 +883,8 @@ restart_go:
 .Lsigaltstack: .long  sys_sigaltstack
 .Ltrace:       .long  syscall_trace
 .Lvfork:       .long  sys_vfork
+.Ltracesysent: .long  trace_real_syscall_entry
+.Ltracesysext: .long  trace_real_syscall_exit 
 
 .Lschedtail:   .long  schedule_tail
 
diff -Nurp linux-2.4.22-clean/arch/s390/kernel/process.c linux-2.4.22-adeos-ltt/arch/s390/kernel/process.c
--- linux-2.4.22-clean/arch/s390/kernel/process.c	2003-06-13 07:51:32.000000000 -0700
+++ linux-2.4.22-adeos-ltt/arch/s390/kernel/process.c	2003-11-21 23:21:08.000000000 -0800
@@ -36,6 +36,7 @@
 #include <linux/delay.h>
 #include <linux/reboot.h>
 #include <linux/init.h>
+#include <linux/trace.h>
 
 #include <asm/uaccess.h>
 #include <asm/pgtable.h>
@@ -129,6 +130,10 @@ int arch_kernel_thread(int (*fn)(void *)
                 : "d" (clone_arg), "i" (__NR_clone), "i" (__NR_exit),
                   "d" (arg), "d" (fn), "i" (__LC_KERNEL_STACK) , "i" (-STACK_FRAME_OVERHEAD)
                 : "2", "3", "4" );
+#if (CONFIG_TRACE || CONFIG_TRACE_MODULE)                           
+        if (retval > 0)                                             
+          TRACE_PROCESS(TRACE_EV_PROCESS_KTHREAD, retval, (int) fn);
+#endif
         return retval;
 }
 
diff -Nurp linux-2.4.22-clean/arch/s390/kernel/sys_s390.c linux-2.4.22-adeos-ltt/arch/s390/kernel/sys_s390.c
--- linux-2.4.22-clean/arch/s390/kernel/sys_s390.c	2001-03-19 12:35:11.000000000 -0800
+++ linux-2.4.22-adeos-ltt/arch/s390/kernel/sys_s390.c	2003-11-21 23:21:08.000000000 -0800
@@ -24,6 +24,7 @@
 #include <linux/mman.h>
 #include <linux/file.h>
 #include <linux/utsname.h>
+#include <linux/trace.h>
 
 #include <asm/uaccess.h>
 #include <asm/ipc.h>
@@ -145,6 +146,8 @@ asmlinkage int sys_ipc (uint call, int f
         struct ipc_kludge tmp;
 	int ret;
 
+        TRACE_IPC(TRACE_EV_IPC_CALL, call, first);
+
         switch (call) {
         case SEMOP:
                 return sys_semop (first, (struct sembuf *)ptr, second);
